import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { ELEMENT_DELETE } from '../elementStatus';
import createClipElement from '../createClipElement';
export default (function (element, animation, nextAttrs, lastAttrs) {
  if (!animation) return null; // 获取shape的默认属性

  var status = element.get('status');
  var clip = animation.clip,
      start = animation.start,
      end = animation.end,
      easing = animation.easing,
      delay = animation.delay,
      duration = animation.duration; // 裁剪动画

  if (clip) {
    var type = clip.type,
        attrs = clip.attrs,
        clipStart = clip.start;
    var clipElement = createClipElement(type, {
      attrs: _objectSpread(_objectSpread({}, attrs), clipStart)
    }); // 默认用 animation 配置里的 easing 和 duration

    clip.easing = clip.easing || easing;
    clip.delay = typeof clip.delay === 'number' ? clip.delay : delay;
    clip.duration = clip.duration || duration;
    clip.element = clipElement;
  }

  var defaultAttrs = element.getDefaultAttrs();
  return _objectSpread(_objectSpread({}, animation), {}, {
    start: _objectSpread(_objectSpread(_objectSpread({}, defaultAttrs), lastAttrs), start),
    end: _objectSpread(_objectSpread({}, status === ELEMENT_DELETE ? null : nextAttrs), end)
  });
});